Index: /trunk/kernel/devices/dev_fbf.c
===================================================================
--- /trunk/kernel/devices/dev_fbf.c	(revision 656)
+++ /trunk/kernel/devices/dev_fbf.c	(revision 657)
@@ -101,6 +392,553 @@
     chdev_t   * fbf_ptr = GET_PTR( fbf_xp );
 
-// check fbf_xp definition
-assert( (fbf_xp != XPTR_NULL) , "undefined FBF chdev descriptor" );
+    // get frame buffer width
+    uint32_t fbf_width  = hal_remote_l32( XPTR( fbf_cxy , &fbf_ptr->ext.fbf.width ) );
+
+    // get pointer on driver command function
+    dev_cmd_t * cmd = hal_remote_lpt( XPTR( fbf_cxy , &fbf_ptr->cmd ) );
+
+    // build extended pointers on windows xlist root
+    xptr_t  windows_root_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_root );
+
+    // get window size and coordinates
+    uint32_t  p_min     = hal_remote_l32( XPTR( window_cxy , &window_ptr->p_min ) );
+    uint32_t  l_min     = hal_remote_l32( XPTR( window_cxy , &window_ptr->l_min ) );
+    uint32_t  w_pixels  = hal_remote_l32( XPTR( window_cxy , &window_ptr->width  ) );
+
+    error = 0;
+
+    // loop on target window lines (FBF coordinates) 
+    for( line = l_min + line_first ; line < (l_min + line_last) ; line++ )
+    {
+        // reset the line buffer to default value
+        for( pixel = 0 ; pixel < w_pixels ; pixel++ ) line_buffer[pixel] = 127;
+
+        // loop on all windows
+        XLIST_FOREACH( windows_root_xp , iter_xp )
+        {
+            // get pointers on remote window
+            xptr_t         tgt_xp  = XLIST_ELEMENT( iter_xp , fbf_window_t , xlist );
+            fbf_window_t * tgt_ptr = GET_PTR( window_xp );
+            cxy_t          tgt_cxy = GET_CXY( window_xp );
+
+            bool_t hidden = hal_remote_l32( XPTR( tgt_cxy , &tgt_ptr->hidden ) );
+
+            // fill the line_buf for this window if not hidden
+            if( hidden == false ) handle_one_window( line,               // line index
+                                                     p_min,              // pixel_min
+                                                     p_min + w_pixels,   // pixel_max 
+                                                     tgt_xp,             // window_xp      
+                                                     line_buffer );      
+        }  // end for windows
+
+        // compute offset in FBF
+        uint32_t fbf_offset = p_min + (line * fbf_width);
+
+        // register command in calling thread descriptor
+        this->fbf_cmd.dev_xp    = fbf_xp;
+        this->fbf_cmd.type      = FBF_DRIVER_KERNEL_WRITE;
+        this->fbf_cmd.buffer    = line_buffer;
+        this->fbf_cmd.npixels   = w_pixels;
+        this->fbf_cmd.offset    = fbf_offset;
+
+        // call driver to display one line
+        cmd( XPTR( local_cxy , this ) );
+
+        error |= this->fbf_cmd.error;
+    
+    }  // end for lines
+
+#if DEBUG_DEV_FBF
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] core[%x,%d] exit / wid %d / cycle %d\n",
+__FUNCTION__, local_cxy, this->core->lid, wid, cycle );
+#endif
+
+    // return I/O operation status
+    return error;
+
+}  // end fbf_update()
+
+//////////////////////////////////////////////
+error_t dev_fbf_delete_window( uint32_t  wid )
+{
+    kmem_req_t     req;
+
+    thread_t  * this    = CURRENT_THREAD;
+    process_t * process = this->process;
+
+#if DEBUG_DEV_FBF
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] enters : wid %d / cycle %d\n",
+__FUNCTION__ , process->pid, this->trdid, wid, cycle );
+#endif
+
+    // get cluster and pointers on FBF chdev
+    xptr_t      fbf_xp  = chdev_dir.fbf[0];
+    cxy_t       fbf_cxy = GET_CXY( fbf_xp );
+    chdev_t   * fbf_ptr = GET_PTR( fbf_xp );
+
+    // build extended pointers on windows lock, and wid allocator 
+    xptr_t windows_lock_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_lock );
+    xptr_t wid_bitmap_xp   = XPTR( fbf_cxy ,  fbf_ptr->ext.fbf.windows_bitmap );
+
+    // build extended pointer on relevant entry in windows_tbl[] array
+    xptr_t  windows_tbl_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_tbl[wid] );
+
+    // get extended pointer on remote window descriptor
+    xptr_t window_xp  = hal_remote_l64( windows_tbl_xp );
+
+    if( window_xp == XPTR_NULL )
+    {
+        printk("\n[ERROR] in %s / thread[%x,%x] / wid %d non registered\n",
+        __FUNCTION__, process->pid, this->trdid, wid );
+        return -1;
+    }
+
+    // get cluster and local pointer on remote window
+    cxy_t          window_cxy = GET_CXY( window_xp );
+    fbf_window_t * window_ptr = GET_PTR( window_xp );
+
+    // get process owner PID
+    pid_t owner_pid = hal_remote_l32( XPTR( window_cxy , &window_ptr->pid ) );
+
+    // check caller PID / owner PID
+    if( owner_pid != process->pid )
+    {
+        printk("\n[ERROR] in %s : caller PID (%x) != owner PID (%x)\n",
+        __FUNCTION__, process->pid , owner_pid );
+        return -1;
+    }
+
+    // get associated buffer, and number of lines
+    uint8_t  * buffer = hal_remote_lpt( XPTR( window_cxy , &window_ptr->buffer ) );
+    uint32_t   nlines = hal_remote_l32( XPTR( window_cxy , &window_ptr->height ) );
+
+    // 1. take the lock protecting windows in write mode
+    remote_rwlock_wr_acquire( windows_lock_xp );
+
+    // 2. update the FBF window
+    fbf_update( window_xp , 0 , nlines );
+
+    // 3. remove the window from windows_tbl[] array
+    hal_remote_s64( windows_tbl_xp , XPTR_NULL );
+
+    // 4. remove the window from xlist      
+    xlist_unlink( XPTR( window_cxy , &window_ptr->xlist ) );
+
+    // 5. release wid to bitmap
+    bitmap_remote_clear( wid_bitmap_xp , wid );
+
+    // 6. release the lock protecting windows in write mode
+    remote_rwlock_wr_release( windows_lock_xp );
+ 
+    // 7. release memory allocated for window descriptor
+    req.type = KMEM_KCM;
+    req.ptr  = window_ptr;
+    kmem_remote_free( window_cxy , &req );
+
+    // 8. release the associated vseg
+    vmm_global_delete_vseg( process , (intptr_t)buffer );
+    
+#if DEBUG_DEV_FBF
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
+__FUNCTION__ , process->pid, this->trdid, cycle );
+#endif
+
+    return 0;
+
+}  // end dev_fbf_delete_window()
+
+////////////////////////////////////////////
+error_t dev_fbf_move_window( uint32_t  wid,
+                             uint32_t  l_min,
+                             uint32_t  p_min )
+{
+    thread_t  * this    = CURRENT_THREAD;
+    process_t * process = this->process;
+
+#if DEBUG_DEV_FBF
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] enters : wid %d / l_min %d / p_min %d / cycle %d\n",
+__FUNCTION__ , process->pid, this->trdid, wid, l_min, p_min, cycle );
+#endif
+
+    // get cluster and pointers on FBF chdev
+    xptr_t      fbf_xp  = chdev_dir.fbf[0];
+    cxy_t       fbf_cxy = GET_CXY( fbf_xp );
+    chdev_t   * fbf_ptr = GET_PTR( fbf_xp );
+
+    // build extended pointers on windows lock and root 
+    xptr_t windows_lock_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_lock );
+    xptr_t windows_root_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_root );
+
+    // build extended pointer on relevant entry in windows_tbl[] array
+    xptr_t  windows_tbl_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_tbl[wid] );
+
+    // get extended pointer on remote window descriptor
+    xptr_t window_xp  = hal_remote_l64( windows_tbl_xp );
+
+    if( window_xp == XPTR_NULL )
+    {
+        printk("\n[ERROR] in %s / thread[%x,%x] / wid %d non registered\n",
+        __FUNCTION__, process->pid, this->trdid, wid );
+        return -1;
+    }
+
+    // get cluster and local pointer for remote window
+    cxy_t          window_cxy = GET_CXY( window_xp );
+    fbf_window_t * window_ptr = GET_PTR( window_xp );
+
+    // get process owner PID, coordinates, and number of lines
+    pid_t    owner_pid = hal_remote_l32( XPTR( window_cxy , &window_ptr->pid ) );
+    uint32_t p_zero    = hal_remote_l32( XPTR( window_cxy , &window_ptr->p_min ) );
+    uint32_t l_zero    = hal_remote_l32( XPTR( window_cxy , &window_ptr->l_min ) );
+    uint32_t nlines    = hal_remote_l32( XPTR( window_cxy , &window_ptr->height ) );
+
+    // check caller PID / owner PID
+    if( owner_pid != process->pid )
+    {
+        printk("\n[ERROR] in %s : caller PID (%x) != owner PID (%x)\n",
+        __FUNCTION__, process->pid , owner_pid );
+        return -1;
+    }
+
+    // does nothing if no change
+    if( (p_zero == p_min) && (l_zero == l_min) )  return 0;
+
+    // 1. take the lock protecting windows in write mode
+    remote_rwlock_wr_acquire( windows_lock_xp );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] lock taken\n", __FUNCTION__ );
+#endif
+
+    // 2. gives the window the lowest priority 
+    xptr_t xlist_entry_xp =  XPTR( window_cxy , &window_ptr->xlist );
+    xlist_unlink( xlist_entry_xp );
+    xlist_add_first( windows_root_xp , xlist_entry_xp );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] set low priority \n", __FUNCTION__ );
+#endif
+
+    // 3. set the "hidden" flag in window descriptor
+    hal_remote_s32( XPTR( window_cxy , &window_ptr->hidden ) , true );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] hidden set\n", __FUNCTION__ );
+#endif
+
+    // 4. refresh the FBF for the current window position
+    fbf_update( window_xp , 0 , nlines );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] refreshed old position\n", __FUNCTION__ );
+#endif
+
+    // 5. set the new coordinates in the window descriptor,
+    hal_remote_s32( XPTR( window_cxy , &window_ptr->l_min ), l_min );
+    hal_remote_s32( XPTR( window_cxy , &window_ptr->p_min ), p_min );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] l_min & p_min updated\n", __FUNCTION__ );
+#endif
+
+    // 6. gives the window the highest priority 
+    xlist_unlink( xlist_entry_xp );
+    xlist_add_last( windows_root_xp , xlist_entry_xp );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] set high priority\n", __FUNCTION__ );
+#endif
+
+    // 7. reset the "hidden" flag in window descriptor
+    hal_remote_s32( XPTR( window_cxy , &window_ptr->hidden ) , false );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] hidden reset\n", __FUNCTION__ );
+#endif
+
+    // 8. refresh the FBF for the new window position
+    fbf_update( window_xp , 0 , nlines );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] refresh new position\n", __FUNCTION__ );
+#endif
+
+    // 9. release the lock protecting windows in write mode
+    remote_rwlock_wr_release( windows_lock_xp );
+ 
+#if DEBUG_DEV_FBF
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
+__FUNCTION__ , process->pid, this->trdid, cycle );
+#endif
+
+    return 0;
+
+}  // end dev_fbf_move_window()
+
+/////////////////////////////////////////////
+error_t dev_fbf_resize_window( uint32_t  wid,
+                               uint32_t  width,
+                               uint32_t  height )
+{
+    thread_t  * this    = CURRENT_THREAD;
+    process_t * process = this->process;
+
+#if DEBUG_DEV_FBF
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] enters : wid %d / width %d / height %d / cycle %d\n",
+__FUNCTION__ , process->pid , this->trdid , wid, width , height , cycle );
+#endif
+
+    // get cluster and pointers on FBF chdev
+    xptr_t      fbf_xp  = chdev_dir.fbf[0];
+    cxy_t       fbf_cxy = GET_CXY( fbf_xp );
+    chdev_t   * fbf_ptr = GET_PTR( fbf_xp );
+
+    // build extended pointers on windows lock and root 
+    xptr_t windows_lock_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_lock );
+    xptr_t windows_root_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_root );
+
+    // build extended pointer on relevant entry in windows_tbl[] array
+    xptr_t  windows_tbl_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_tbl[wid] );
+
+    // get extended pointer on remote window descriptor
+    xptr_t window_xp  = hal_remote_l64( windows_tbl_xp );
+
+    if( window_xp == XPTR_NULL )
+    {
+        printk("\n[ERROR] in %s / thread[%x,%x] / wid %d non registered\n",
+        __FUNCTION__, process->pid, this->trdid, wid );
+        return -1;
+    }
+
+    // get cluster and local pointer for remote window
+    cxy_t          window_cxy = GET_CXY( window_xp );
+    fbf_window_t * window_ptr = GET_PTR( window_xp );
+
+    // get process owner PID, width, height, and buffer
+    pid_t    owner_pid = hal_remote_l32( XPTR( window_cxy , &window_ptr->pid ) );
+    uint32_t nlines    = hal_remote_l32( XPTR( window_cxy , &window_ptr->height ) );
+    uint32_t npixels   = hal_remote_l32( XPTR( window_cxy , &window_ptr->width ) );
+    void   * base      = hal_remote_lpt( XPTR( window_cxy , &window_ptr->buffer ) );
+
+    // check caller PID / owner PID
+    if( owner_pid != process->pid )
+    {
+        printk("\n[ERROR] in %s : caller PID (%x) != owner PID (%x)\n",
+        __FUNCTION__, process->pid , owner_pid );
+        return -1;
+    }
+
+    // does nothing if no change
+    if( (width == npixels) && (height == nlines) ) return 0;
+
+    // compute old_size and new size
+    uint32_t old_size = nlines * npixels;
+    uint32_t new_size = width * height;
+
+    // 1. take the lock protecting windows in write mode
+    remote_rwlock_wr_acquire( windows_lock_xp );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] lock taken\n", __FUNCTION__ );
+#endif
+
+    // 2. gives the window the lowest priority (remove, then add first)
+    xptr_t xlist_entry_xp =  XPTR( window_cxy , &window_ptr->xlist );
+    xlist_unlink( xlist_entry_xp );
+    xlist_add_first( windows_root_xp , xlist_entry_xp );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] set low priority\n", __FUNCTION__ );
+#endif
+
+    // 3. set the "hidden" flag in window descriptor
+    hal_remote_s32( XPTR( window_cxy , &window_ptr->hidden ) , true );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] hidden set\n", __FUNCTION__ );
+#endif
+
+    // 4. refresh the FBF for the current window size
+    fbf_update( window_xp , 0 , nlines );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] refreshed old window\n", __FUNCTION__ );
+#endif
+
+    // 5. set the new width & height in the window descriptor,
+    hal_remote_s32( XPTR( window_cxy , &window_ptr->width  ), width );
+    hal_remote_s32( XPTR( window_cxy , &window_ptr->height ), height );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] width & height updated\n", __FUNCTION__ );
+#endif
+
+    // 6. resize vseg if required
+    vmm_global_resize_vseg( process, (intptr_t)base, (intptr_t)base, width * height );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] vseg resized\n", __FUNCTION__ );
+#endif
+
+    // 7. fill buffer extension if required
+    if( new_size > old_size )  memset( base + old_size , 0 , new_size - old_size );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] buffer extension initialized\n", __FUNCTION__ );
+#endif
+
+    // 8. gives the window the highest priority 
+    xlist_unlink( xlist_entry_xp );
+    xlist_add_last( windows_root_xp , xlist_entry_xp );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] set high priority\n", __FUNCTION__ );
+#endif
+
+    // 9. reset the "hidden" flag in window descriptor
+    hal_remote_s32( XPTR( window_cxy , &window_ptr->hidden ) , false );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] hidden reset\n", __FUNCTION__ );
+#endif
+
+    // 10. refresh the FBF for the new window position
+    fbf_update( window_xp , 0 , height );
+
+#if ( DEBUG_DEV_FBF & 1 )
+printk("\n[%s] refresh new position\n", __FUNCTION__ );
+#endif
+
+    // 11. release the lock protecting windows in write mode
+    remote_rwlock_wr_release( windows_lock_xp );
+ 
+#if DEBUG_DEV_FBF
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
+__FUNCTION__ , process->pid, this->trdid, cycle );
+#endif
+
+    return 0;
+
+}  // end dev_fbf_resize_window()
+
+///////////////////////////////////////////////
+error_t dev_fbf_refresh_window( uint32_t  wid,
+                                uint32_t  line_first,
+                                uint32_t  line_last )
+{
+    // get local pointers on calling thread and process
+    thread_t  * this    = CURRENT_THREAD;
+    process_t * process = this->process;
+
+#if DEBUG_DEV_FBF
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] enters for wid %d / first %d / last %d / cycle %d\n",
+__FUNCTION__ , process->pid, this->trdid, wid, line_first, line_last, cycle );
+#endif
+
+    // get cluster and pointers on FBF chdev
+    xptr_t      fbf_xp  = chdev_dir.fbf[0];
+    cxy_t       fbf_cxy = GET_CXY( fbf_xp );
+    chdev_t   * fbf_ptr = GET_PTR( fbf_xp );
+
+    // build extended pointer on windows lock
+    xptr_t  windows_lock_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_lock );
+
+    // build extended pointer on relevant entry in windows_tbl[] array
+    xptr_t  windows_tbl_xp  = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_tbl[wid] );
+
+    // get pointers on remote window descriptor
+    xptr_t         window_xp  = hal_remote_l64( windows_tbl_xp );
+    cxy_t          window_cxy = GET_CXY( window_xp );
+    fbf_window_t * window_ptr = GET_PTR( window_xp );
+
+    // check <wid> argument
+    if( window_xp == XPTR_NULL )
+    {
+        printk("\n[ERROR] in %s / thread[%x,%x] / wid %d non registered\n",
+        __FUNCTION__, process->pid, this->trdid, wid );
+        return -1;
+    }
+
+    // get process owner PID
+    pid_t owner_pid = hal_remote_l32( XPTR( window_cxy , &window_ptr->pid ) );
+
+    // check caller PID / owner PID
+    if( owner_pid != process->pid )
+    {
+        printk("\n[ERROR] in %s : caller PID (%x) != owner PID (%x)\n",
+        __FUNCTION__, process->pid , owner_pid );
+        return -1;
+    }
+
+    // get number of lines in window
+    uint32_t nlines = hal_remote_l32( XPTR( window_cxy , &window_ptr->height ) ); 
+
+    // check <line_first> and <line_last> arguments
+    if( (line_first >= nlines) || (line_last > nlines) || (line_first >= line_last) )
+    {
+        printk("\n[ERROR] in %s : illegal (l_first %d , l_last %d) / height %d\n",
+        __FUNCTION__, line_first, line_last, nlines );
+        return -1;
+    }
+
+    // take the lock protecting windows xlist in read mode
+    remote_rwlock_rd_acquire( windows_lock_xp );
+
+    // update FBF 
+    fbf_update( window_xp , line_first , line_last );
+
+    // release the lock protecting windows xlist in write mode
+    remote_rwlock_rd_release( windows_lock_xp );
+
+#if DEBUG_DEV_FBF
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] exit for wid %d / cycle %d\n",
+__FUNCTION__, process->pid, this->trdid, wid, cycle );
+#endif
+
+    return 0;
+
+}  // end dev_fbf_refresh_window()
+
+///////////////////////////////////////////////
+// TODO Deprecated : january 2020 [AG]
+///////////////////////////////////////////////
+error_t dev_fbf_move_data( bool_t     is_write,
+                           void     * user_buffer,
+                           uint32_t   npixels,
+                           uint32_t   offset )
+{
+    // get pointer on calling thread
+    thread_t * this = CURRENT_THREAD;
+
+#if DEBUG_DEV_FBF
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] :  buffer %x / npixels %d / offset %x / cycle %d\n",
+__FUNCTION__ , this->process->pid, this->trdid,  
+user_buffer, npixels, offset, cycle );
+#endif
+
+    // get pointers on FBF chdev
+    xptr_t      fbf_xp  = chdev_dir.fbf[0];
+    cxy_t       fbf_cxy = GET_CXY( fbf_xp );
+    chdev_t   * fbf_ptr = GET_PTR( fbf_xp );
 
     // get frame buffer width and height
@@ -108,14 +946,18 @@
     uint32_t height = hal_remote_l32 ( XPTR( fbf_cxy , &fbf_ptr->ext.fbf.height ) );
 
-// check offset and length versus FBF size
-assert( ((offset + length) <= (width * height)) ,
-"offset %d / length %d / width %d / height %d\n", offset, length, width, height ); 
+    // check offset and npixels versus FBF size
+    if( ((offset + npixels) > (width * height)) )
+    {
+        printk("\n[ERROR] in %s : offset (%d) + npixels (%d) / width (%d) / height (%d)\n",
+        __FUNCTION__, offset, npixels, width, height ); 
+        return -1;
+    }
 
     // register command in calling thread descriptor
     this->fbf_cmd.dev_xp    = fbf_xp;
-    this->fbf_cmd.type      = cmd_type;
+    this->fbf_cmd.type      = is_write ? FBF_DRIVER_USER_WRITE : FBF_DRIVER_USER_READ;
     this->fbf_cmd.buffer    = user_buffer;
     this->fbf_cmd.offset    = offset;
-    this->fbf_cmd.length    = length;
+    this->fbf_cmd.npixels   = npixels;
 
     // get driver command function
@@ -130,7 +972,6 @@
 cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_DEV_FBF < cycle )
-printk("\n[%s] thread[%x,%x] completes %s / error = %d / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid,  
-dev_fbf_cmd_str(cmd_type), error , cycle );
+printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
+__FUNCTION__ , this->process->pid, this->trdid, cycle );
 #endif
 
@@ -139,2 +980,4 @@
 
 }  // end dev_fbf_move_data()
+
+
